# core/plugs/mbox.py
#
#

""" mailbox input plugin. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import j, error, parse_email, short_date, ftime
from core import kernel, Object

import email.message
import mailbox
import datetime
import logging
import email
import time
import os

## CMNDS

def mbox(event):
    fn = os.path.abspath(os.path.expanduser(event.parsed.args[0]))
    nr = 0
    for m in mailbox.mbox(fn):
        o = Object()
        o.update(m.items())
        o.text = ""
        for load in m.walk():
            if load.get_content_type() == 'text/plain': o.text += load.get_payload()
        o.text = o.text.replace("\\n", "\n")
        o.save()
        nr += 1
    event.ok(nr)

kernel.ctrl.register("mbox", mbox)
